
#include <string.h>
#include <process.h>
#include <stdio.h>
#include <winsock.h>

#define WELCOME "Welcome"

void server(void *par)
{
  SOCKET s=(SOCKET) par;
  char buf[100];
  int rcvLen;
  int err;

  send( s, WELCOME , strlen(WELCOME), 0);

  for (;;)
  {
    rcvLen=recv(s, buf, sizeof(buf)-1, 0);
    if (rcvLen)
    {
      buf[rcvLen]=0;
      printf( "%s", buf);

      strrev(buf);

	    err=send( s, buf, strlen(buf), 0);
      if (err==SOCKET_ERROR)
      {
        printf("error\n");
        break;
      }
    }
  }
  printf("Spojeni ukonceno\n");
  err=closesocket(s);
}


int main(int argc, char* argv[])
{
  SOCKET s;
  WSADATA WSAData;
  struct sockaddr_in sai;
  int err;

  int port;

  printf("Zadej port, kterem spustit server: ");
  scanf("%d",&port);

  err=WSAStartup( MAKEWORD( 1, 1), &WSAData);
  if (err==SOCKET_ERROR)
  {
	  printf("Chyba WSAStartup\n");
	  return 1;
  }

  s=socket( AF_INET, SOCK_STREAM, 0);
  if (INVALID_SOCKET==err)
  { 
    printf( "Chyba socket\n"); 
    return 1; 
  }
				//start server;
  SOCKET sa;
  int sail;
  struct sockaddr_in server_addr_port;

  server_addr_port.sin_family=AF_INET;
  server_addr_port.sin_port=htons( port);
  server_addr_port.sin_addr.S_un.S_addr=INADDR_ANY;

  err=bind( s, (struct sockaddr*) &server_addr_port, sizeof( server_addr_port));
  if (SOCKET_ERROR==err) \
  { 
    printf( "Chyba Bind\n");
    return 1;
  }
  
  err=listen( s, 5);
  if (SOCKET_ERROR==err) \
  { 
    printf( "Chyba Listen\n");
    return 1;
  }
  for (;;)
  {
    sa=accept( s, (struct sockaddr*) &sai, &sail );
    if (INVALID_SOCKET==err)
    { 
      printf( "Chyba accept\n");
      return 1;
    }
    printf( "Spojeni navazano\n");
    _beginthread( server, NULL, (void *) sa);
  }
  
  return 0;
}

